import java.util.*;  
import java.sql.*;  
/**  
  * Klassen anvendes til at sikre global tilgang til VaresalgsSystem objektet
  * og hermed modelkomponenten  
  * Klassen giver samtidig et singleton-mnster, der sikre at der kun er et objekt.
  * 
  * Klassen fungerer som controler overordnet for modelkomponenten.
  * 
  * @version  November 2002, februar 2004
  * @author   Bjrk Busch
*/  

public class GlobalModel
{
  // Overordnet VaresalgsSystem objekt
  private  static  VaresalgsSystem  varesalgsSystem = new VaresalgsSystem();

  // Tilgang til varesalgsSystem
  private  static  VaresalgsSystem  getVaresalgsSystem()
  {    return  varesalgsSystem;   }

  // Anvendes til klargring af modelkomponenten
  public  static void  open ()
  {
    try
    { varesalgsSystem = (VaresalgsSystem)FileManager.loadModel("data/","varesalgssystem.dat");  }
    catch (Exception  e)
    { System.out.println("Exception ved close");  }  
  }

  // sikrer endelig tilbageskrivning af modelkomponenten
  public  static void  close ()
  {
    try
    { FileManager.saveModel("data/","varesalgssystem.dat",varesalgsSystem); }
    catch (Exception  e)
    { System.out.println("Exception ved close"); }  
  }



}
