import java.io.*;  
import java.util.*;  
import java.util.Date;  
import java.sql.Timestamp;  
/**  
  * @version  November 2002
  * @author   Bjrk Busch
*/  

public class Kunde implements Serializable
{  
  public  static  int      TILSTAND_AKTIV = 0;
  public  static  int      TILSTAND_NEDLAGT = 1;

  private   String         navn;
  private   String         gade;
  private   int            postnr;
  private   String         by;
  private   String         tlf;
  private   Timestamp      oprettetDato;      // EKSTRA
  private   Timestamp      nedlagtDato;
  private   int            tilstand;

  private   Vector         varesalgsVector = new Vector();

  // Constructor til at oprette object
  public   Kunde ( String  navn,
                   String  gade,
                   int     postnr,
                   String  by, 
                   String  tlf )
  {
    this.navn             = navn;
    this.gade             = gade;
    this.postnr           = postnr;
    this.by               = by;
    this.tlf              = tlf;
    this.oprettetDato     = new Timestamp((new Date()).getTime());   // EKSTRA - tidspunkt nu
    this.tilstand         = TILSTAND_AKTIV;
  }

  //------- getmetoder
  public  String     getNavn   ( )  {  return (this.navn);   }
  public  String     getGade   ( )  {  return (this.gade);   }
  public  int        getPostnr ( )  {  return (this.postnr);   }
  public  String     getBy     ( )  {  return (this.by);   }
  public  String     getTlf    ( )  {  return (this.tlf);   }

  public  Timestamp  getOprettetDato ( )
  {    return (Timestamp)this.oprettetDato.clone();  }

  public   Timestamp   getNedlagtDato ( )
  {
    if (this.nedlagtDato == null) return null;
    return (Timestamp)this.nedlagtDato.clone();
  }

  public   int   getTilstand ( )
  {  return (this.tilstand);   }

  public    String   toString()
  {
    return ("" + getNavn ( )
            + ","+ getGade ( )
            + ","+ getPostnr ( )
            + ","+ getBy ( )
            + ","+ getTlf ( )
            + ","+ getOprettetDato ( )
            + ","+ getNedlagtDato ( )
            + ","+ getTilstand ( )
            );
  }

  //------- ekstra metoder

  public   void   retStamdata ( String  navn,
                                String  gade,
                                int     postnr,
                                String  by,
                                String  tlf   )
  {
    this.navn             = navn;
    this.gade             = gade;
    this.postnr           = postnr;
    this.by               = by;
    this.tlf              = tlf;
  }

  
  // registrering af kunde nedlagt
  public   void   nedlaeg (Timestamp nedlagtDato)
  {  
    this.nedlagtDato = nedlagtDato;
    this.tilstand    = TILSTAND_NEDLAGT;
  }

  public   Varesalg   opretVaresalg ( Timestamp dato, double kvantum, double pris,
                                      Vare vare )
  { 
   Varesalg varesalg = new Varesalg(dato, kvantum, pris, vare,this);
   this.varesalgsVector.add(varesalg);
   vare.connect(varesalg);
   return varesalg;
  }

  public   int  getAntalVaresalg ()
  {  return varesalgsVector.size();   }

  public   Varesalg   getVaresalg ( int index )
  {  return (Varesalg)varesalgsVector.get(index);   }

  public   Iterator   getVaresalgIterator ()
  {  return varesalgsVector.iterator();   }

  public   void  sletKundeData ( )
  {  
    // ikke realiseret endnu
  }



}  
